{
    Copyright (C) 2010  Andrew Stawowczyk Long

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact: info@dohm.com.au

}
// ver2.0.0.3 - Minor bug fix
// ver2.0.0.2 - SpyderChecker and SpyderChkr24 support added. QPcard 203 removed as
//              it never worked properly.
// ver2.0.0.1 - Argyll binary updated to 2.0.1
//              LaserSoft Advanced 864 patch target support added
// ver1.9.7.6 - Cropping option added to Large View window. Update to languages.
// ver1.9.7.5 - Added drag and drop option for the target image.
//              Argyll binary updated to 2.0
// ver1.9.7.4 - Argyll binary updated to 1.9.2
// ver1.9.7.2 - Further work on White Point and Dark Areas Emphasis boxes.
// ver1.9.7.1 - Argyll binary updated to 1.9.1
//              White Point and Dark Areas Emphasis boxes prevented from loading
//              values from ini file that are outside of limits.
// ver1.9.6.0 - Argyll binary updated to 1.8.3
//              Languages updated
//              English and German help file updated
// ver1.9.5.0 - removed LOG option due to permission problems
// ver1.9.4.0 - added profile intent
// ver1.9.3.4 - Argyll ver1.8.2
//              Changed White Point input - spin box with 2 dec point precision
//              New input for adjusting dark areas (-V demphasis)

// ver1.9.3.3 - Added option to save the log
// ver1.9.3.2 - tidying up
// ver1.9.3 - Some bugs fixing
// ver1.9.2 - Option to switch logging off
//            Change of upgrade button function - previous updater caused problems
// ver1.9.0 - Argyll version updated to 1.8.0
//            Improved handling of temporary files to avoid permission problems.
//            View current log option added.
// ver1.8.0 - Argyll version updated to 1.7.0.
//            Algorithm list expanded to include all options available in Argyll.
//            Capture button removed due to bugs in TWAIN opening module.
//            Installer includes now Argyll 32 and 64-bit.
// ver1.7.8I - special version for InoTec
// ver1.7.8 - added support for German language. Argyll updated to v1.6.2
// ver1.7.7 - added support for QPcard 202 and 203
// ver1.7.6 - reversed to ver 1.7.0 - Argyll colprof arguments to be clarified. Argyll updated to ver1.4.0
// ver1.7.5 - added option to change gamma of the target.
//            updated Argyll to v1.3.5
//            fixed TWAIN scanning bug.
//            update from URL instead direct of download.
//            installation program checks for running instances of CoCa.
// ver1.7.0 - updated Argyll to v1.3.3 and ImageEn component to v4.0
//            Preview now with file name and image size in pixels.
//            changed contact and download details from NLA to personal.
//            NOTE: Previous versions of CoCa are copyright of Andrew Stawowczyk Long and National Library of Australia.
// ver1.6.0 - various bits updated
// ver1.5.9 - removed "recommended only for scanners" from IT8.7 description;
//            installation program removes "coca_setup.exe" on startup, if exists
// ver1.5.8 - minor fixes of Spanish & English spelling, updated Argyll version to 1.3.2
// ver1.5.7 - minor bugs fixed
// ver1.5.6 - added Spanish
// ver1.5.5 -  added RGB values read in Preview pane.
// ver1.5.2 - added support for Indonesian language

unit coca_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, PJShellFolders, ExtCtrls, ExtDlgs, ShellAPI,
  INIFILES, ieview, imageenview, ieopensavedlg, jpeg, WinXP, registry,
  ShFolder, Shlobj, AdvSmoothPanel, AdvGroupBox, AdvOfficeButtons,
  AdvGlassButton, AdvPanel, ComCtrls, cxdrive10, imageenio, auHTTP,
  auAutoUpgrader, plsController, Menus, Lucombo, dblucomb, AdvTrackBar,
  plsDialogs, LangConsts, AdvSpin, JclFileUtils, OleCtrls, 
  AdvCombo, Mask, DragDrop, DropTarget, DragDropFile;

type
  TForm1 = class(TForm)
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenImageEnDialog;
    OpenDialog2: TOpenDialog;
    Target_Panel: TAdvSmoothPanel;
    Panel_1: TAdvSmoothPanel;
    Panel_3: TAdvSmoothPanel;
    Panel_2: TAdvSmoothPanel;
    ImgLabel: TLabel;
    AdvPanel1: TAdvPanel;
    image1: TImageEnView;
    TargetBtn: TAdvGlassButton;
    Profile_Panel: TAdvSmoothPanel;
    Panel_7: TAdvSmoothPanel;
    Panel_8: TAdvSmoothPanel;
    scanner_edit: TDBLUEdit;
    model_edit: TDBLUEdit;
    descr_edit: TDBLUEdit;
    copy_edit: TDBLUEdit;
    Label1: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Panel_Bottom: TAdvPanel;
    HelpBtn: TAdvGlassButton;
    ExitBtn: TAdvGlassButton;
    CreateBtn: TAdvGlassButton;
    UpgBtn: TAdvGlassButton;
    AboutBtn: TAdvGlassButton;
    ImageEnIO1: TImageEnIO;
    RefLabel: TLabel;
    Label3: TLabel;
    infoBtn_2: TAdvGlassButton;
    Panel_4: TAdvSmoothPanel;
    Panel_6: TAdvSmoothPanel;
    infoBtn_1: TAdvGlassButton;
    infoBtn_3: TAdvGlassButton;
    infoBtn_4: TAdvGlassButton;
    prog1: TProgressBar;
    Image2: TImage;
    typeList: TAdvComboBox;
    algList: TAdvComboBox;
    perspectiveBox: TAdvOfficeCheckBox;
    Panel_5: TAdvSmoothPanel;
    infoBtn_5: TAdvGlassButton;
    infoBtn_6: TAdvGlassButton;
    infoBtn_7: TAdvGlassButton;
    infoBtn_8: TAdvGlassButton;
    ArgyllBtn: TAdvGlassButton;
    pumLanguages: TPopupMenu;
    LangBtn: TAdvGlassButton;
    genBtn: TAdvGlassButton;
    refBtn: TAdvGlassButton;
    GammaSpin: TAdvSpinEdit;
    pls_lang: TplsController;
    upg1: TauAutoUpgrader;
    WP_spin: TAdvSpinEdit;
    Label2: TLabel;
    Label5: TLabel;
    dark_spin: TAdvSpinEdit;
    Panel1: TPanel;
    intent_list: TAdvComboBox;
    qualList: TAdvComboBox;
    Label8: TLabel;
    Panel2: TPanel;
    DropFileTarget1: TDropFileTarget;

    procedure TargetBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure CreateBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    function FindWin: string;
    procedure FormActivate(Sender: TObject);
    function BrowseURL(const URL: string) : boolean;
    function GetSpecialFolderPath(folder : integer) : string;
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure UpgBtnClick(Sender: TObject);
    procedure upg1Error(Sender: TObject);
    procedure RefBtnClick(Sender: TObject);
    procedure infoBtn_1Click(Sender: TObject);
    procedure genBtnClick(Sender: TObject);
    procedure infoBtn_2Click(Sender: TObject);
    procedure AboutBtnClick(Sender: TObject);
    procedure OpenImg(s: string);
    procedure image1Progress(Sender: TObject; per: Integer);
    procedure infoBtn_3Click(Sender: TObject);
    procedure infoBtn_4Click(Sender: TObject);
    procedure typeListDropUp(Sender: TObject);
    procedure image1Click(Sender: TObject);
    procedure infoBtn_5Click(Sender: TObject);
    procedure infoBtn_6Click(Sender: TObject);
    procedure infoBtn_7Click(Sender: TObject);
    procedure infoBtn_8Click(Sender: TObject);
    procedure ArgyllBtnClick(Sender: TObject);
    procedure image1KeyPress(Sender: TObject; var Key: Char);
    procedure LangBtnClick(Sender: TObject);
    procedure pumLanguagesClick(Sender:TObject);
    Procedure FileCopy( Const sourcefilename, targetfilename: string );
    function GetWindowsLanguage(LCTYPE: LCTYPE {type of information}): string;
    procedure pls_langLanguageChanged(Sender: TObject);
    procedure WP_spinKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure WP_spinExit(Sender: TObject);
    procedure dark_spinExit(Sender: TObject);
    procedure dark_spinKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DropFileTarget1Drop(Sender: TObject; ShiftState: TShiftState;
      APoint: TPoint; var Effect: Integer);


  private
    { Private declarations }
    function RefreshDriveInfo(StateIndex: string): int64;
    function Get_File_Size(const S: string): Int64;
    function SpaceInfo: boolean;
    procedure LanguageChanged(Sender:TObject);
    function GetTempDirectory: String;
    procedure Proc_Run(ProgramName : String; Wait: Boolean);
    function GetAppVersionStr: string;
    procedure GetBuildInfo(var V1, V2, V3, V4: Word);
    function whitepoint: string;
    function darkareas: string;
    function chart_type: string;
    function Algorithm: string;
    function Intent: string;
    function Quality_proc: string;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  target_file, out_file, tar_dir, ref_dir, prof_dir, checker_cie, checker,
  scanner, model, descr, copyright, common, pth, help_file, gamma: string;
  m, alg: string[1];
  global_language: string;
  temp_img: boolean;
  stateindex, quality: integer;
  temp_path: string;


implementation

uses coca_ref, coca_about, coca_prev, plsLangMan;

{$R *.dfm}

procedure TForm1.TargetBtnClick(Sender: TObject);
begin
  opendialog1.PreviewCheckBox.Checked:=false;
  OPenDIalog1.InitialDir:=tar_dir;
  OpenDialog1.FileName:='';
  If OpenDialog1.Execute then
  begin
   Screen.Cursor:=crHourglass;
   prog1.Position:=0;
   prog1.Visible:=true;
   target_file:= OpenDialog1.FileName;
   tar_dir:= ExtractFilePath(OpenDialog1.FileName);
   ImgLabel.Caption:= ExtractFileName(OpenDialog1.FileName);
   OpenImg(target_file);
   TargetBtn.OuterBorderColor:=clRed;
  end
    else
    begin
     Image1.Blank;
     TargetBtn.OuterBorderColor:=clWhite;
    end;
  Screen.Cursor:=crDefault;
  prog1.Visible:=false;

end;

procedure TForm1.typeListDropUp(Sender: TObject);
begin
case typeList.ItemIndex of
        0: image2.Picture.LoadFromFile(pth+'help\colorchecker.jpg');
        1: image2.Picture.LoadFromFile(pth+'help\colorcheckerSG.jpg');
        2: image2.Picture.LoadFromFile(pth+'help\colorchecker_passport.jpg');
        3: image2.Picture.LoadFromFile(pth+'help\colorchecker.jpg');
        4: image2.Picture.LoadFromFile(pth+'help\CMP-003.jpg');
        5: image2.Picture.LoadFromFile(pth+'help\CMP-3.jpg');
        6: image2.Picture.LoadFromFile(pth+'help\CMP-3.jpg');
        7: image2.Picture.LoadFromFile(pth+'help\HCT.jpg');
        8: image2.Picture.LoadFromFile(pth+'help\LSDC.jpg');
        9: image2.Picture.LoadFromFile(pth+'help\qp.jpg');
        10: image2.Picture.LoadFromFile(pth+'help\qp2.jpg');
        11: image2.Picture.LoadFromFile(pth+'help\it8.jpg');
        12: image2.Picture.LoadFromFile(pth+'help\LaserSoftAdv.jpg');
        13: image2.Picture.LoadFromFile(pth+'help\SpyderChecker.jpg');
        14: image2.Picture.LoadFromFile(pth+'help\SpyderChecker24.jpg');

        else
          image2.Picture.LoadFromFile(pth+'help\colorchecker.jpg');
   end;
 form1.Refresh;
end;

procedure TForm1.OpenImg(s: string);
begin
  try
    Image1.IO.LoadFromFile(s);
  except
    Image1.Blank;
    Screen.Cursor:=crDefault;
    Application.MessageBox(PChar(StrErrorOpeningTheIm), PChar(Application.Title), mb_Ok or mb_IconInformation);
  end;
end;

procedure TForm1.pls_langLanguageChanged(Sender: TObject);
var
 i: integer;
begin
  plsDialogs.LanguageChanged;               // update constants (variables) in plsDialogs unit
  LangConsts.LanguageChanged;               // update user defined constants (variables)
  LanguageManager.Clear(True,False);        // clear localization strings table for constants
  if not LanguageManager.LangVCL(Self) then // update vcl properties for this form
    MessageDlgLM(Caption,LanguageManager.LastError,mtWarning,[mbOK]);

  Application.Title:=Self.Caption;          // update application title if you want

  for i := 0 to Screen.FormCount - 1 do                         // inform other forms/frames/modules that language changed
    SendMessage(Screen.Forms[i].Handle,WM_LANGUAGECHANGED,0,0); // main form must not have WMLanguageChanged method
  image1.Repaint;
end;

procedure TForm1.upg1Error(Sender: TObject);
begin
 Application.MessageBox(PChar(StrAnErrorHasOccurre +#13#10#10+
     Str1NoInternetConn +#13#10+  Str2UpdateFileNot +#13#10+  Str3UserAbortedUpg), PChar(Application.Title), mb_Ok or mb_IconStop);
end;

procedure TForm1.ExitBtnClick(Sender: TObject);
begin
  close;
end;

function Tform1.WhitePoint: string;
begin
  if WP_spin.FloatValue=1.00 then
    Result:= ''
    else
       Result:= '-U '+FloatToStr(WP_spin.FloatValue)+' ';
end;

function Tform1.DarkAreas: string;
begin
  if dark_spin.FloatValue=1.00 then
    Result:= ''
    else
       Result:= '-V '+FloatToStr(dark_spin.FloatValue)+' ';
end;

procedure TForm1.dark_spinExit(Sender: TObject);
begin
   if dark_spin.FloatValue<>1.0 then
     dark_spin.Color:=clRed
     else
       dark_spin.Color:=clWindow;
   dark_spin.Repaint;  
end;

procedure TForm1.dark_spinKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (dark_spin.FloatValue>3.0) OR (dark_spin.FloatValue<1.0) then
   begin
     Application.MessageBox(PChar(StrDarkAreas), PChar(Application.Title),
                                                   mb_Ok or mb_IconInformation);

     dark_spin.Text:='1.00';
   end;
end;


procedure TForm1.WP_spinExit(Sender: TObject);
begin
   if WP_spin.FloatValue<>1.0 then
     WP_spin.Color:=clRed
     else
       WP_spin.Color:=clWindow;
   wp_spin.Repaint;
end;

procedure TForm1.WP_spinKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (WP_spin.FloatValue>1.5) OR (WP_spin.FloatValue<0.5) then
   begin
     Application.MessageBox(PChar(StrWPAdjust), PChar(Application.Title),
                                                   mb_Ok or mb_IconInformation);
     WP_spin.Text:='1.00';
   end;

end;

function TForm1.chart_type:string;
begin
  case typeList.ItemIndex of
    0: Result:= 'ColorChecker.cht';
    1: Result:= 'ColorCheckerSG.cht';
    2: Result:= 'ColorCheckerPassport.cht';
    3: Result:= 'ColorChecker.cht';
    4: Result:= 'CMP_DT_003.cht';
    5: Result:= 'CMP_Digital_Target-4.cht';
    6: Result:= 'CMP_Digital_Target-7.cht';
    7: Result:= 'Hutchcolor.cht';
    8: Result:= 'LaserSoftDCPro.cht';
    9: Result:= 'QPcard_201.cht';
    10: Result:= 'QPcard_202.cht';
    11: Result:= 'it8.cht';
    12: Result:= 'LaserSoftAdv.cht';
    13: Result:= 'SpyderChecker.cht';
    14: Result:= 'SpyderChecker24.cht';
    else
      Result:= pth+'ColorChecker.cht';
   end;
end;

function TForm1.Quality_proc: string;
begin
Case QualList.ItemIndex of
   0: Result:='l';
   1: Result:='m';
   2: Result:='h';
   3: Result:='u';
  else
    Result:='m';
  end;
end;

function TForm1.Algorithm: string;
begin
case algList.ItemIndex of
  0: Result:= 'l';
  1: Result:= 'x';
  2: Result:= 'g';
  3: Result:= 's';
  4: Result:= 'X';
  5: Result:= 'm';
  6: Result:= 'G';
  7: Result:= 'S';
  else
    Result:='l';
  end;
end;

function TForm1.Intent: string;
begin
case intent_List.ItemIndex of
  0: Result:= '-Z p ';
  1: Result:= '-Z r ';
  2: Result:= '-Z s ';
  3: Result:= '-Z a '
  else
    Result:='';
  end;
end;

procedure TForm1.CreateBtnClick(Sender: TObject);
var
  proc: textfile;
  fle, sc, md, wp, dark, desc, cop, w_dir, test_dir, test_dir2, perspective,
  temporary_target_file, p_intent: string;
  error: integer;

begin
  if GammaSpin.Text='2.2' then
    gamma:=''
    else
      gamma:= '-G '+GammaSpin.Text+' ';

  wp:= WhitePoint;
  dark:= DarkAreas;
  checker:= chart_type;
  m:=  Quality_proc;
  alg:= Algorithm;
  p_intent:= Intent;

  If (Image1.IEBitmap.Height<100) then
   begin
    MessageDlg(StrPleaseSelectValid, mtInformation, [mbOk], 0);
    Exit;
   end;

   If NOT (FileExists(checker_cie)) then
   begin
     MessageDlg(StrPleaseSelectRefere, mtInformation, [mbOk], 0);
     Exit;
   end;


If SpaceInfo then
begin
      test_dir:= extractFilePath(target_file);
      test_dir2:= test_dir+'testdir_'+inttostr(random(10000));

      {$IOChecks off}
      MkDir(test_dir2);
      error := IOResult;

      if error = 0 then
      begin
        RmDir(test_dir2);
        {$IOChecks on}

        If scanner_edit.Text='' then
         sc:=StrCamera
         else
          sc:=scanner_edit.Text;

        If model_edit.Text='' then
         md:=StrModel
         else
          md:=model_edit.Text;

        If descr_edit.Text='' then
        begin
         desc:='CoCa';
         descr_edit.Text:='CoCa';
        end
         else
          desc:=descr_edit.Text;

        If copy_edit.Text='' then
         cop:=StrCopyrightfree
         else
          cop:=copy_edit.Text;

        if perspectiveBox.Checked then
          perspective:= '-p '
          else
            perspective:= '';

        If DirectoryExists(temp_path) then
          DeleteDirectory(temp_path, true);

       {$IOChecks off}
        MkDir(temp_path);
        error := IOResult;
        if error <> 0 then
            ShowMessageFmt('Directory creation failed with error %d',[error]);
       {$IOChecks on}

        FileCopy(target_file, temp_path+ExtractFileName(target_file));
        temporary_target_file:= temp_path+ExtractFileName(target_file);

        fle:= temp_path+'proc.bat';

        Assignfile(proc, fle);
        Rewrite(proc);
        Writeln(proc, '@echo off');
        Writeln(proc, '"'+pth+'argyll\bin\scanin" -v '+gamma+perspective+
                '"'+temporary_target_file+'" "'+pth+'argyll\ref\'+checker+'" "'+checker_cie+'"');
        Closefile(proc);
        Proc_Run('"'+fle+'"', true);

        If FileExists(ChangeFileExt(temporary_target_file, '.ti3')) then
        begin
          AssignFile(proc, fle);
          Rewrite(proc);
          Writeln(proc, '@echo off');
          Writeln(proc,'"'+pth+'argyll\bin\colprof" -v -A"'+sc+'" -M"'+md+
                        '" -D"'+desc+'" -C"'+cop+'" -q'+m+' -a'+alg+' '+p_intent+wp+dark+'"'+ChangeFileExt(temporary_target_file, '')+'"');
          CloseFile(proc);

          Proc_Run('"'+fle+'"', true);
          w_dir:=FindWin;
          SaveDialog1.FileName:='';
          SaveDialog1.InitialDir:=prof_dir;
          SaveDialog1.DefaultExt:= '*.icm';
          SaveDialog1.Filter:= StrICCProfileFile;
          SaveDialog1.Title:= StrSaveProfile;

          If SaveDialog1.Execute then
          begin
           out_file:=SaveDialog1.FileName;
           FileCopy(PChar(ChangeFileExt(temporary_target_file, '.icm')), PChar(out_file));
           MessageDlg(StrICCProfileSavedTo+#13#13+ExtractFilePath(SaveDialog1.FileName), mtInformation, [mbOk], 0);
          end;
       end
       else
         MessageDlg(StrERRORExtractingRGB, mtInformation, [mbOk], 0);
   end
   else
     begin
        Application.MessageBox(PChar(StrERRORPleaseMakeS), PChar(Application.Title), mb_Ok or mb_IconInformation);
        exit;
      end;

end
else
 exit;
if directoryexists(test_dir2) then
   RmDir(test_dir2);


end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=VK_F1 then
  BrowseURL(ExtractFilePath(Application.ExeName)+'coca.html');
end;

procedure TForm1.genBtnClick(Sender: TObject);
var
  f: TForm8;
  i: integer;

begin
f:= TForm8.Create(nil);
try
 i:=f.ShowModal;
finally
  f.Release;
end;

case i of
2: begin
    typeList.ItemIndex:=0;
    checker_cie:=pth+'argyll\ref\'+'ColorChecker.cie';
    RefLabel.Caption:= ExtractFileName(checker_cie);
   genBtn.OuterBorderColor:=clRed;
   refBtn.OuterBorderColor:=clWhite;
   end;

3: begin
    typeList.ItemIndex:=2;
    checker_cie:=pth+'argyll\ref\'+'ColorCheckerPassport.cie';
    RefLabel.Caption:= ExtractFileName(checker_cie);
   genBtn.OuterBorderColor:=clRed;
   refBtn.OuterBorderColor:=clWhite;
   end;

4: begin
    typeList.ItemIndex:=9;
    checker_cie:=pth+'argyll\ref\'+'QPcard_201.cie';
    RefLabel.Caption:= ExtractFileName(checker_cie);
   genBtn.OuterBorderColor:=clRed;
   refBtn.OuterBorderColor:=clWhite;
  end;

5: begin
    typeList.ItemIndex:=10;
    checker_cie:=pth+'argyll\ref\'+'QPcard_202.cie';
    RefLabel.Caption:= ExtractFileName(checker_cie);
   genBtn.OuterBorderColor:=clRed;
   refBtn.OuterBorderColor:=clWhite;
  end;

6: begin
    typeList.ItemIndex:=13;
    checker_cie:=pth+'argyll\ref\'+'SpyderChecker.cie';
    RefLabel.Caption:= ExtractFileName(checker_cie);
   genBtn.OuterBorderColor:=clRed;
   refBtn.OuterBorderColor:=clWhite;
  end;

7: begin
    typeList.ItemIndex:=14;
    checker_cie:=pth+'argyll\ref\'+'SpyderChecker24.cie';
    RefLabel.Caption:= ExtractFileName(checker_cie);
   genBtn.OuterBorderColor:=clRed;
   refBtn.OuterBorderColor:=clWhite;
  end;

-1: begin
  genBtn.OuterBorderColor:=clWhite;
  refBtn.OuterBorderColor:=clWhite;
  exit;
 end
  else
    exit;

end;
 typeListDropUp(sender);
end;


function TForm1.GetWindowsLanguage(LCTYPE: LCTYPE {type of information}): string;
var
  Buffer : PChar;
  Size : integer;
begin
  Size := GetLocaleInfo (LOCALE_USER_DEFAULT, LCType, nil, 0);
  GetMem(Buffer, Size);
  try
    GetLocaleInfo (LOCALE_USER_DEFAULT, LCTYPE, Buffer, Size);
    Result := string(Buffer);
  finally
    FreeMem(Buffer);
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  myINI : TINIFile;
  i,j:Integer;
  MI,MI2:TMenuItem;
  AL:TStringList;
  temp_str: string;
  lg: integer;

begin
 CreateMutex(nil, False, 'CoCaMutex');
 Form1.Left:=120;
 Form1.Top:=80;
 pth:=ExtractFilePath(Application.ExeName);
 temp_str:= GetTempDirectory;
 temp_path:=temp_str+'coca\';
 if NOT DirectoryExists(temp_str) then
 begin
  Application.MessageBox('Temporary User Folder not accessible. Program will not work correctly.' , PChar(Application.Title), mb_Ok or mb_IconInformation);
  temp_path:='';
 end;
 help_file:=pth+'help\coca.html';
 checker_cie:='';
 checker:='';
 target_file:='';
 common:= GetSpecialFolderPath(26);
 if NOT (directoryexists(common+'\coca')) then
    begin
     {$I-}
     MkDir(common+'\coca');
     {$I+}
    end;

   IEFileFormatRemove(ioRAW); // disables internal RAW support
   IEAddExtIOPlugIn(pth+'dcrawlib.dll');

   Image1.Blank;
   temp_img:=false;
   myINI := TINIFile.Create(common+'\coca\coca.ini');
   tar_dir:=myINI.ReadString('Directories', 'TARGET', GetSpecialFolderPath(CSIDL_MYPICTURES));
   ref_dir:=myINI.ReadString('Directories', 'REFERENCE', GetSpecialFolderPath(CSIDL_PERSONAL));
   scanner_edit.Text:=myINI.ReadString('Settings', 'CAMERA', 'Camera');
   model_edit.Text:=myINI.ReadString('Settings', 'MODEL', 'Model');
   descr_edit.Text:=myINI.ReadString('Settings', 'DESCRIPTION', 'CoCa');
   copy_edit.Text:=myINI.ReadString('Settings', 'COPYRIGHT', 'Copyright_free');

   typeList.ItemIndex:= myINI.ReadInteger('Settings', 'TYPE', 0);
   algList.ItemIndex:= myINI.ReadInteger('Settings', 'ALGORITHM', 2);
   intent_List.ItemIndex:= myINI.ReadInteger('Settings', 'INTENT', 0);
   quality:= myINI.ReadInteger('Settings', 'QUALITY',2);
   global_language:=myINI.ReadString('Settings', 'LANGUAGE', '');
   WP_spin.FloatValue:=myINI.ReadFloat('Settings', 'WhitePoint', 1.00);
   dark_spin.FloatValue:=myINI.ReadFloat('Settings', 'DarkAreas', 1.00);

   lg:= myINI.ReadInteger('Settings', 'log_check', 1);
   myINI.Free;
   prof_dir:= FindWin+'\system32\spool\drivers\color';

  LanguageManager.OnLanguageChanged:=LanguageChanged; // assign language changed event
  if LanguageManager.LanguageCode<>'' then
    LanguageChanged(LanguageManager);

   AL:=TStringList.Create;                             // fill menu items with available languages
  pumLanguages.Items.Clear;
  try
    LanguageManager.GetAvailableLanguages(AL);
    for i := 0 to AL.Count - 1 do
    begin
      MI:=TMenuItem.Create(self);
      MI2:=TMenuItem.Create(self);
      MI.Hint:=AL.Names[i];
      MI2.Hint:=MI.Hint;
      {$IFDEF VER130}
      MI.Caption:=AL.Values[MI.Hint];
      {$ELSE}
      MI.Caption:=AL.ValueFromIndex[i];
      {$ENDIF}
      MI2.Caption:=MI.Caption;
      MI.OnClick:=pumLanguagesClick;
      MI2.OnClick:=MI.OnClick;
      for j := 0 to pumLanguages.Items.Count - 1 do
        if MI.Caption<pumLanguages.Items[j].Caption then
        begin
          pumLanguages.Items.Insert(j,MI);
          Break;
        end;
      if MI.Parent=nil then
      begin
        pumLanguages.Items.Add(MI);
      end;
    end;
  finally
    AL.Free;
  end;

   typeListDropUp(sender);

   if global_language='' then
    begin
     LanguageManager.LanguageCode:= GetWindowsLanguage(LOCALE_SISO639LANGNAME);
      if Length(LanguageManager.LastError)>0 then
        MessageDlg('ERROR in Language Module. Contact developer.',mtWarning,[mbOK], 0);
    end
    else
        LanguageManager.LanguageCode:=global_language;
end;


procedure TForm1.HelpBtnClick(Sender: TObject);
begin
  BrowseURL(help_file);
end;

procedure TForm1.image1Click(Sender: TObject);
var
  f: TForm2;
begin
 if image1.IEBitmap.Width>1 then
 begin
  f:= TForm2.Create(nil);
try
  f.Caption:=Form2Title;
  f.ShowModal;
finally
  f.Release;
end;
  if new_image<>'' then
    target_file:= new_image;

  image1.IO.LoadFromFile(target_file);
  ImgLabel.Caption:= ExtractFileName(target_file);
 end
 else
   Application.MessageBox(PChar(StrNoImageToProcess), PChar(Application.Title), mb_Ok or mb_IconInformation);
end;

procedure TForm1.image1KeyPress(Sender: TObject; var Key: Char);
begin
 image1Click(sender);
end;

procedure TForm1.image1Progress(Sender: TObject; per: Integer);
begin
  prog1.StepBy(per);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  myINI : TINIFile;
begin
    myINI := TINIFile.Create(common+'\coca\coca.ini');
    myINI.WriteString('Directories', 'TARGET', tar_dir);
    myINI.WriteString('Directories', 'REFERENCE', ref_dir);
    myINI.WriteString('Settings', 'CAMERA', scanner_edit.text);
    myINI.WriteString('Settings', 'MODEL', model_edit.text);
    myINI.WriteString('Settings', 'DESCRIPTION', descr_edit.text);
    myINI.WriteString('Settings', 'COPYRIGHT', copy_edit.text);
    myINI.WriteInteger('Settings', 'TYPE', typeList.ItemIndex);
    myINI.WriteInteger('Settings', 'ALGORITHM', algList.ItemIndex);
    myINI.WriteInteger('Settings', 'INTENT', intent_List.ItemIndex);    
    myINI.WriteInteger('Settings', 'QUALITY', qualList.ItemIndex);
    myINI.WriteString('Settings', 'LANGUAGE', LanguageManager.LanguageCode);
    myINI.WriteFloat('Settings', 'WhitePoint', WP_spin.FloatValue);
    myINI.WriteFloat('Settings', 'DarkAreas', dark_spin.FloatValue);
    myINI.Free;

    if DirectoryExists(temp_path) then
     DeleteDirectory(temp_path, True);
end;

function TForm1.FindWin:string;
var
  PWindowsDir: array [0..255] of Char;

begin
  GetWindowsDirectory(PWindowsDir,255);
  Result:=StrPas(PWindowsDir);
end;

procedure TForm1.AboutBtnClick(Sender: TObject);
begin
  Form6.ShowModal;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 Image1.LegacyBitmap:=false;
end;

procedure TForm1.UpgBtnClick(Sender: TObject);
begin
  Showmessage('Your CoCa version is: '+GetAppVersionStr+#13#10#10+'Click OK to see current CoCa version number available at'
  +#13#10#10+'http://www.dohm.com.au/coca/downloads/coca_setup.exe');
  BrowseURL('http://www.dohm.com.au/coca/downloads/coca_version.htm');
end;

function TForm1.SpaceInfo: boolean;
var
 file_dr: string;
 my_res, my_file: string;
 i, j: int64;

begin
 result:=false;
 file_dr:=ExtractFileDrive(target_file);
 i:= Get_File_Size(target_file);
 j:= RefreshDriveInfo(File_dr);

 if NOT (i=-1) then
 begin
  i:=i*2;
  my_file:=formatfloat('0.00',i/1048576);
  my_res:=formatfloat('0.00',(j/1048576));
    if i>=j then
    begin
      result:=false;
      Application.MessageBox(PChar(StrNotEnoughSpaceOn+my_res+StrMBRequiredMinimum+my_file+'MB'), PChar(Application.Title), mb_Ok or mb_IconInformation);
    end
  else
   result:=true;
 end;

end;

procedure TForm1.infoBtn_1Click(Sender: TObject);
begin
    Application.MessageBox(PChar(StrCoCaWorksWithALi+#13#10+#13#10+

              StrColorChecker+#13#10+
              StrColorCheckSG +#13#10+
              StrCMPColorChecker +#13#10+
              StrChristopheMt+#13#10+
              StrChristopheMte+#13#10+
              StrHutchColorHC +#13#10+
              StrLaserSoftDCP +#13#10+
              StrQPcard201+#13#10+
              StrQPcard202+#13#10+
              StrIT87Recomm+#13#10+
              StrLaserSoftAdv+#13#10+#13#10+
                StrGenericReferenceFi), PChar(Application.Title), mb_Ok or mb_IconInformation);
end;

procedure TForm1.infoBtn_3Click(Sender: TObject);
begin
  Application.MessageBox(PChar(StrMakeSureThatYouH), PChar(Application.Title), mb_Ok or mb_IconInformation);

end;

procedure TForm1.infoBtn_4Click(Sender: TObject);
begin
  Application.MessageBox(PChar(StrIfTheTargetImage), PChar(Application.Title), mb_Ok or mb_IconInformation);

end;

procedure TForm1.infoBtn_5Click(Sender: TObject);
begin
 Application.MessageBox(PChar(StrUseTheSliderToAd), PChar(Application.Title), mb_Ok or mb_IconInformation);
end;

procedure TForm1.infoBtn_6Click(Sender: TObject);
begin
   Application.MessageBox(PChar(StrSelectTheCorrectT), PChar(Application.Title), mb_Ok or mb_IconInformation);
end;

procedure TForm1.infoBtn_7Click(Sender: TObject);
begin
  Application.MessageBox(PChar(StrThisInformationIs), PChar(Application.Title), mb_Ok or mb_IconInformation);
end;

procedure TForm1.infoBtn_8Click(Sender: TObject);
begin
  Application.MessageBox(PChar(StrDifferentAlgorithms), PChar(Application.Title), mb_Ok or mb_IconInformation);
end;

procedure TForm1.LangBtnClick(Sender: TObject);
var
 x_p, y_p: integer;
begin
  x_p:=mouse.CursorPos.X;
  y_p:= mouse.CursorPos.Y;
  pumLanguages.Popup(x_p,y_p);
end;

procedure TForm1.ArgyllBtnClick(Sender: TObject);
begin
  BrowseURL(pth+'argyll\doc\ArgyllDoc.html');
end;

function TForm1.BrowseURL(const URL: string) : boolean;
var
   Browser: string;
begin
   Result := True;
   Browser := '';
   with TRegistry.Create do
   try
     RootKey := HKEY_CLASSES_ROOT;
Access := KEY_QUERY_VALUE;
     if OpenKey('\htmlfile\shell\open\command', False) then
       Browser := ReadString('') ;
     CloseKey;
   finally
     Free;
   end;
   if Browser = '' then
   begin
     Result := False;
     Exit;
   end;
   Browser := Copy(Browser, Pos('"', Browser) + 1, Length(Browser)) ;
   Browser := Copy(Browser, 1, Pos('"', Browser) - 1) ;
   ShellExecute(0, 'open', PChar('"'+Browser+'"'), PChar('"'+URL+'"'), nil, SW_SHOW) ;
end;

function TForm1.GetSpecialFolderPath(folder : integer) : string;
const
  SHGFP_TYPE_CURRENT = 0;
var
  path: array [0..MAX_PATH] of char;
begin
  if SUCCEEDED(SHGetFolderPath(0,folder,0,SHGFP_TYPE_CURRENT,@path[0])) then
    Result := path
  else
    Result := '';
end;

procedure TForm1.RefBtnClick(Sender: TObject);
begin
 RefLabel.Caption:='';
 checker_cie:='';
 OpenDialog2.InitialDir:= ref_dir;
 OpenDialog2.Title:=StrSelectReferenceFil;
 OpenDialog2.Filter:='All Files (*.*)|*.*';

 if OpenDialog2.Execute then
 begin
   checker_cie:=OpenDialog2.FileName;
   RefLabel.Caption:= ExtractFileName(checker_cie);
   ref_dir:= ExtractFilePath(checker_cie);
   genBtn.OuterBorderColor:=clWhite;
   refBtn.OuterBorderColor:=clRed;
 end
 else
 begin
   genBtn.OuterBorderColor:=clWhite;
   refBtn.OuterBorderColor:=clWhite;
 end;
end;

procedure TForm1.infoBtn_2Click(Sender: TObject);
begin
   Application.MessageBox(PChar(StrGenericReferenceFil+#13#10+
              StrForAllOtherTarget), PChar(Application.Title), mb_Ok or mb_IconInformation);
end;

function TForm1.RefreshDriveInfo(StateIndex: string): int64;
var
  i: Integer;
begin
 Result:=-1;

 if StateIndex='C:' then
   i:=2;

 if StateIndex='D:' then
   i:=3;

 if StateIndex='E:' then
   i:=4;

 if StateIndex='F:' then
   i:=5;

 if StateIndex='G:' then
   i:=6;

 if StateIndex='H:' then
   i:=7;

 if StateIndex='I:' then
   i:=8;

 if StateIndex='J:' then
   i:=9;

 if StateIndex='K:' then
   i:=10;

 if StateIndex='L:' then
   i:=11;

 if StateIndex='M:' then
   i:=12;

 if StateIndex='N:' then
   i:=13;

 if StateIndex='O:' then
   i:=14;

 if StateIndex='P:' then
   i:=15;

 if StateIndex='Q:' then
   i:=16;

 if StateIndex='R:' then
   i:=17;

  if StateIndex='S:' then
   i:=18;

 if StateIndex='T:' then
   i:=19;

 if StateIndex='U:' then
   i:=20;

 if StateIndex='V:' then
   i:=21;

 if StateIndex='W:' then
   i:=22;

 if StateIndex='X:' then
   i:=23;

 if StateIndex='Y:' then
   i:=24;

 if StateIndex='Z:' then
   i:=25;

 if cxDrive[i].Available.AsBoolean then
  Result:= cxDrive[i].Space.BytesAvailable.AsNumber;

end;

function TForm1.Get_File_Size(const S: string): Int64;
var
  SearchRec: TSearchRec;
  sgPath: string;
  inRetval, I1: Integer;
begin
  sgPath := ExpandFileName(s);
  try
    inRetval := FindFirst(ExpandFileName(s), faAnyFile, SearchRec);
    if inRetval = 0 then
      I1 := SearchRec.Size
    else
      I1 := -1;
  finally
    SysUtils.FindClose(SearchRec);
  end;
  Result := I1;
end;

procedure TForm1.LanguageChanged(Sender:TObject);
var
 i: integer;
 
begin
  plsDialogs.LanguageChanged;               // update constants (variables) in plsDialogs unit
  LangConsts.LanguageChanged;               // update user defined constants (variables)
  LanguageManager.Clear(True,False);        // clear localization strings table for constants
  if not LanguageManager.LangVCL(Self) then // update vcl properties for this form
    MessageDlgLM(Caption,LanguageManager.LastError,mtWarning,[mbOK]);

  Application.Title:=Self.Caption;          // update application title if you want

  for i := 0 to Screen.FormCount - 1 do                         // inform other forms/frames/modules that language changed
    SendMessage(Screen.Forms[i].Handle,WM_LANGUAGECHANGED,0,0); // main form must not have WMLanguageChanged method
  image1.Repaint;
  qualList.ItemIndex:= quality;
end;

procedure TForm1.pumLanguagesClick(Sender:TObject);
begin
  LanguageManager.LanguageCode:=TMenuItem(Sender).Hint; // load another language files
  if Length(LanguageManager.LastError)>0 then
    MessageDlg('ERROR',mtWarning,[mbOK], 0);
end;

Procedure TForm1.FileCopy( Const sourcefilename, targetfilename: string );
Var
  S, T: TFileStream;
Begin
  S := TFileStream.Create( sourcefilename, fmOpenRead );
  try
    T := TFileStream.Create( targetfilename,
                             fmOpenWrite or fmCreate );
    try
      T.CopyFrom(S, S.Size ) ;
    finally
      T.Free;
    end;
  finally
    S.Free;
  end;
End;

function TForm1.GetTempDirectory: String;
var
  tempFolder: array[0..MAX_PATH] of Char;
begin
  GetTempPath(MAX_PATH, @tempFolder);
  result := StrPas(tempFolder);
end;

procedure TForm1.Proc_Run(ProgramName : String; Wait: Boolean);
var
  StartInfo : TStartupInfo;
  ProcInfo : TProcessInformation;
  CreateOK : Boolean;
begin
    { fill with known state }
  FillChar(StartInfo,SizeOf(TStartupInfo),#0);
  FillChar(ProcInfo,SizeOf(TProcessInformation),#0);
  StartInfo.cb := SizeOf(TStartupInfo);
  CreateOK := CreateProcess(nil, PChar(ProgramName), nil, nil,False,
              CREATE_NEW_PROCESS_GROUP+NORMAL_PRIORITY_CLASS,
              nil, nil, StartInfo, ProcInfo);
    { check to see if successful }
  if CreateOK then
    begin
        //may or may not be needed. Usually wait for child processes
       if Wait then
         WaitForSingleObject(ProcInfo.hProcess, INFINITE);
    end
  else
    begin
       Application.MessageBox(PChar(StrUnableToRunProgra), PChar(Application.Title), mb_Ok or mb_IconInformation);
     end;

  CloseHandle(ProcInfo.hProcess);
  CloseHandle(ProcInfo.hThread);
end;

function TForm1.GetAppVersionStr: string;
var
  V1,       // Major Version
  V2,       // Minor Version
  V3,       // Release
  V4: Word; // Build Number
begin
  GetBuildInfo(V1, V2, V3, V4);
  Result := IntToStr(V1) + '.'
            + IntToStr(V2) + '.'
            + IntToStr(V3) + '.'
            + IntToStr(V4);
end;

procedure TForm1.GetBuildInfo(var V1, V2, V3, V4: Word);
var
   VerInfoSize, VerValueSize, Dummy : DWORD;
   VerInfo : Pointer;
   VerValue : PVSFixedFileInfo;
begin
VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
GetMem(VerInfo, VerInfoSize);
GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
With VerValue^ do
begin
  V1 := dwFileVersionMS shr 16;
  V2 := dwFileVersionMS and $FFFF;
  V3 := dwFileVersionLS shr 16;
  V4 := dwFileVersionLS and $FFFF;
end;
FreeMem(VerInfo, VerInfoSize);
end;

procedure TForm1.DropFileTarget1Drop(Sender: TObject; ShiftState: TShiftState;
  APoint: TPoint; var Effect: Integer);
var
  Item: string;
begin
   Item:= Trim(dropfiletarget1.Files.GetText);

   image1.IO.LoadFromFile(Item);
   imgLabel.Caption:=ExtractFileName(Item);
   target_file:=Item;
end;

end.
